﻿#region DEFINES
Define IDA_EmptyShellMenu := "EmptyShellMenu"
Define IDA_StandardShellMenu := "StandardShellMenu"
Define IDM_EmptyShellMenu := "EmptyShellMenu"
Define IDM_EmptyShellMenu_File_Exit_ID := 3754
Define IDM_EmptyShellMenu_File_ID := 3747
Define IDM_EmptyShellMenu_File_Open_ID := 3748
Define IDM_EmptyShellMenu_File_Print_Setup_ID := 3750
Define IDM_EmptyShellMenu_File_Send_ID := 3752
Define IDM_EmptyShellMenu_Help_About_ID := 3759
Define IDM_EmptyShellMenu_Help_ID := 3755
Define IDM_EmptyShellMenu_Help_Index_ID := 3756
Define IDM_EmptyShellMenu_Help_Using_Help_ID := 3757
Define IDM_StandardShellMenu := "StandardShellMenu"
Define IDM_StandardShellMenu_Edit_Copy_ID := 17697
Define IDM_StandardShellMenu_Edit_Cut_ID := 17696
Define IDM_StandardShellMenu_Edit_Delete_Record_ID := 17701
Define IDM_StandardShellMenu_Edit_Go_To_Bottom_ID := 17706
Define IDM_StandardShellMenu_Edit_Go_To_Top_ID := 17703
Define IDM_StandardShellMenu_Edit_ID := 17695
Define IDM_StandardShellMenu_Edit_Insert_Record_ID := 17700
Define IDM_StandardShellMenu_Edit_Next_ID := 17705
Define IDM_StandardShellMenu_Edit_Paste_ID := 17698
Define IDM_StandardShellMenu_Edit_Previous_ID := 17704
Define IDM_StandardShellMenu_File_Close_ID := 17687
Define IDM_StandardShellMenu_File_Exit_ID := 17694
Define IDM_StandardShellMenu_File_ID := 17685
Define IDM_StandardShellMenu_File_Open_ID := 32001
Define IDM_StandardShellMenu_File_Print_ID := 17689
Define IDM_StandardShellMenu_File_Print_Setup_ID := 17690
Define IDM_StandardShellMenu_File_Send_ID := 17692
Define IDM_StandardShellMenu_Help_About_ID := 32031
Define IDM_StandardShellMenu_Help_Context_Help_ID := 17716
Define IDM_StandardShellMenu_Help_ID := 17714
Define IDM_StandardShellMenu_Help_Index_ID := 17715
Define IDM_StandardShellMenu_Help_Using_Help_ID := 17717
Define IDM_StandardShellMenu_View_Form_ID := 17708
Define IDM_StandardShellMenu_View_ID := 17707
Define IDM_StandardShellMenu_View_Table_ID := 17709
Define IDM_StandardShellMenu_Window_Cascade_ID := 17711
Define IDM_StandardShellMenu_Window_Close_All_ID := 17713
Define IDM_StandardShellMenu_Window_ID := 17710
Define IDM_StandardShellMenu_Window_Tile_ID := 17712
#endregion

CLASS EmptyShellMenu INHERIT Menu 

CONSTRUCTOR(oOwner) 
	LOCAL oTB AS Toolbar 

	SELF:PreInit()
	SUPER(ResourceID{"EmptyShellMenu", _GetInst( )})

	SELF:RegisterItem(IDM_EmptyShellMenu_File_ID,	;
		HyperLabel{#File,	;
			"&File",	;
			,	;
			"File"}, SELF:Handle(), 0)
	SELF:RegisterItem(IDM_EmptyShellMenu_File_Open_ID,	;
		HyperLabel{#DWBBrowser,	;
			"&Open...	Ctrl+O",	;
			"Open a file",	;
			"File_Open"})
	SELF:RegisterItem(IDM_EmptyShellMenu_File_Print_Setup_ID,	;
		HyperLabel{#FilePrinterSetup,	;
			"P&rint Setup...",	;
			"Setup printer options",	;
			"File_Printer_Setup"})
	SELF:RegisterItem(IDM_EmptyShellMenu_File_Send_ID,	;
		HyperLabel{#MailDlg,	;
			"&Send...",	;
			"Send Mail via MS Exchange",	;
			})
	SELF:RegisterItem(IDM_EmptyShellMenu_File_Exit_ID,	;
		HyperLabel{#FileExit,	;
			"E&xit	Alt+F4",	;
			"End of application",	;
			"File_Exit"})
	SELF:RegisterItem(IDM_EmptyShellMenu_Help_ID,	;
		HyperLabel{#Help,	;
			"&Help",	;
			,	;
			}, SELF:Handle(), 1)
	SELF:RegisterItem(IDM_EmptyShellMenu_Help_Index_ID,	;
		HyperLabel{#HelpIndex,	;
			"&Index	F1",	;
			"Index of help",	;
			"Help_Index"})
	SELF:RegisterItem(IDM_EmptyShellMenu_Help_Using_Help_ID,	;
		HyperLabel{#HelpUsingHelp,	;
			"&Using Help",	;
			"How to use help",	;
			"Help_UsingHelp"})
	SELF:RegisterItem(IDM_EmptyShellMenu_Help_About_ID,	;
		HyperLabel{#HelpAbout,	;
			"&About...",	;
			"About application",	;
			})

	oTB := Toolbar{ }
	oTB:ButtonStyle := TB_ICONONLY
	oTB:Flat := TRUE
	oTB:EnableBands(FALSE)

	oTB:AppendItem(IDT_OPEN,IDM_EmptyShellMenu_File_Open_ID)
	oTB:AddTipText(IDT_OPEN,IDM_EmptyShellMenu_File_Open_ID,"Open File")

	oTB:AppendItem(IDT_HELP,IDM_EmptyShellMenu_Help_About_ID)
	oTB:AddTipText(IDT_HELP,IDM_EmptyShellMenu_Help_About_ID,"Help")

	SELF:ToolBar := oTB

	SELF:Accelerator := EmptyShellMenu_Accelerator{ }

	SELF:PostInit()
	RETURN SELF

END CLASS
CLASS EmptyShellMenu_Accelerator INHERIT Accelerator
 
CONSTRUCTOR( ) 
	SUPER(ResourceID{"EmptyShellMenu_Accelerator", _GetInst( )})
	return self
END CLASS
CLASS StandardShellMenu INHERIT Menu
 
CONSTRUCTOR(oOwner) 
	local oTB as ToolBar

	SUPER(ResourceID{IDM_StandardShellMenu, _GetInst( )})

	self:RegisterItem(IDM_StandardShellMenu_File_ID,	;
		HyperLabel{#File,	;
			"&File",	;
			,	;
			"File"},self:Handle( ),0)
	self:RegisterItem(IDM_StandardShellMenu_File_Open_ID,	;
		HyperLabel{#FileOpen,	;
			"&Open...	Ctrl+O",	;
			"Open a file",	;
			"File_Open"})
	self:RegisterItem(IDM_StandardShellMenu_File_Close_ID,	;
		HyperLabel{#FileClose,	;
			"&Close",	;
			"Close current child window",	;
			"File_Close"})
	self:RegisterItem(IDM_StandardShellMenu_File_Print_ID,	;
		HyperLabel{#FilePrint,	;
			"&Print",	;
			"Print the active window",	;
			,})
	self:RegisterItem(IDM_StandardShellMenu_File_Print_Setup_ID,	;
		HyperLabel{#FilePrinterSetup,	;
			"P&rint Setup...",	;
			"Setup printer options",	;
			"File_Printer_Setup"})
	self:RegisterItem(IDM_StandardShellMenu_File_Send_ID,	;
		HyperLabel{#MailDlg,	;
			"&Send...",	;
			"Send Mail via MS Exchange",	;
			,})
	self:RegisterItem(IDM_StandardShellMenu_File_Exit_ID,	;
		HyperLabel{#FileExit,	;
			"E&xit	Alt+F4",	;
			"End of application",	;
			"File_Exit"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_ID,	;
		HyperLabel{#Edit,	;
			"&Edit",	;
			"Edit information",	;
			"Edit"},self:Handle( ),1)
	self:RegisterItem(IDM_StandardShellMenu_Edit_Cut_ID,	;
		HyperLabel{#Cut,	;
			"Cu&t	Ctrl+X",	;
			"Cut to clipboard",	;
			"Cut"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Copy_ID,	;
		HyperLabel{#Copy,	;
			"&Copy	Ctrl+C",	;
			"Copy to clipboard",	;
			"Copy"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Paste_ID,	;
		HyperLabel{#Paste,	;
			"&Paste	Ctrl+V",	;
			"Paste from clipboard",	;
			"Paste"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Insert_Record_ID,	;
		HyperLabel{#Append,	;
			"&Insert Record",	;
			"Insert a new record",	;
			"Append"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Delete_Record_ID,	;
		HyperLabel{#Delete,	;
			"&Delete Record",	;
			"Delete this record",	;
			"Delete"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Go_To_Top_ID,	;
		HyperLabel{#GoTop,	;
			"G&o To Top	Ctrl+Home",	;
			"Go to first record",	;
			"GoTop"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Previous_ID,	;
		HyperLabel{#SkipPrevious,	;
			"Pre&vious",	;
			"Go to previous record",	;
			"SkipPrevious"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Next_ID,	;
		HyperLabel{#SkipNext,	;
			"&Next",	;
			"Go to next record",	;
			"SkipNext"})
	self:RegisterItem(IDM_StandardShellMenu_Edit_Go_To_Bottom_ID,	;
		HyperLabel{#GoBottom,	;
			"Go To &Bottom	Ctrl+End",	;
			"Go to last record",	;
			"GoBottom"})
	self:RegisterItem(IDM_StandardShellMenu_View_ID,	;
		HyperLabel{#View,	;
			"&View",	;
			,	;
			,},self:Handle( ),2)
	self:RegisterItem(IDM_StandardShellMenu_View_Form_ID,	;
		HyperLabel{#ViewForm,	;
			"&Form	Shift+F2",	;
			"View a single record as a form",	;
			"ViewForm"})
	self:RegisterItem(IDM_StandardShellMenu_View_Table_ID,	;
		HyperLabel{#ViewTable,	;
			"&Table	F2",	;
			"View several records in a table",	;
			"ViewTable"})
	self:RegisterItem(IDM_StandardShellMenu_Window_ID,	;
		HyperLabel{#Window,	;
			"&Window",	;
			"Arrange child windows",	;
			,},self:Handle( ),3)
	self:RegisterItem(IDM_StandardShellMenu_Window_Cascade_ID,	;
		HyperLabel{#WindowCascade,	;
			"&Cascade",	;
			"Arrange child windows in a cascade",	;
			"WindowCascade"})
	self:RegisterItem(IDM_StandardShellMenu_Window_Tile_ID,	;
		HyperLabel{#WindowTile,	;
			"&Tile",	;
			"Arrange child windows tiled",	;
			"WindowTile"})
	self:RegisterItem(IDM_StandardShellMenu_Window_Close_All_ID,	;
		HyperLabel{#CloseAllChildren,	;
			"Close A&ll",	;
			"Close all child windows",	;
			"WindowCloseAll"})
	self:RegisterItem(IDM_StandardShellMenu_Help_ID,	;
		HyperLabel{#Help,	;
			"&Help",	;
			,	;
			,},self:Handle( ),4)
	self:RegisterItem(IDM_StandardShellMenu_Help_Index_ID,	;
		HyperLabel{#HelpIndex,	;
			"&Index	F1",	;
			"Index of help",	;
			"Help_Index"})
	self:RegisterItem(IDM_StandardShellMenu_Help_Context_Help_ID,	;
		HyperLabel{#HelpContext,	;
			"&Context Help	Ctrl+F1",	;
			"Context sensitive help",	;
			"Help_ContextHelp"})
	self:RegisterItem(IDM_StandardShellMenu_Help_Using_Help_ID,	;
		HyperLabel{#HelpUsingHelp,	;
			"&Using Help",	;
			"How to use help",	;
			"Help_UsingHelp"})
	self:RegisterItem(IDM_StandardShellMenu_Help_About_ID,	;
		HyperLabel{#HelpAbout,	;
			"&About...",	;
			"About application",	;
			,})

	self:SetAutoUpDate( 3 )

	oTB := ToolBar{ }

	oTB:ButtonStyle := TB_ICONONLY

	oTB:AppendItem(IDT_CLOSE,IDM_StandardShellMenu_File_Close_ID)
	oTB:AddTipText(IDT_CLOSE,IDM_StandardShellMenu_File_Close_ID,"Close File")

	oTB:AppendItem(IDT_SEPARATOR)

	oTB:AppendItem(IDT_CUT,IDM_StandardShellMenu_Edit_Cut_ID)
	oTB:AddTipText(IDT_CUT,IDM_StandardShellMenu_Edit_Cut_ID,"Cut")

	oTB:AppendItem(IDT_COPY,IDM_StandardShellMenu_Edit_Copy_ID)
	oTB:AddTipText(IDT_COPY,IDM_StandardShellMenu_Edit_Copy_ID,"Copy")

	oTB:AppendItem(IDT_PASTE,IDM_StandardShellMenu_Edit_Paste_ID)
	oTB:AddTipText(IDT_PASTE,IDM_StandardShellMenu_Edit_Paste_ID,"Paste")

	oTB:AppendItem(IDT_SEPARATOR)

	oTB:AppendItem(IDT_STARTREC,IDM_StandardShellMenu_Edit_Go_To_Top_ID)
	oTB:AddTipText(IDT_STARTREC,IDM_StandardShellMenu_Edit_Go_To_Top_ID,"Go Top")

	oTB:AppendItem(IDT_PREVREC,IDM_StandardShellMenu_Edit_Previous_ID)
	oTB:AddTipText(IDT_PREVREC,IDM_StandardShellMenu_Edit_Previous_ID,"Previous Record")

	oTB:AppendItem(IDT_NEXTREC,IDM_StandardShellMenu_Edit_Next_ID)
	oTB:AddTipText(IDT_NEXTREC,IDM_StandardShellMenu_Edit_Next_ID,"Next Record")

	oTB:AppendItem(IDT_ENDREC,IDM_StandardShellMenu_Edit_Go_To_Bottom_ID)
	oTB:AddTipText(IDT_ENDREC,IDM_StandardShellMenu_Edit_Go_To_Bottom_ID,"Go Bottom")

	oTB:AppendItem(IDT_SEPARATOR)

	oTB:AppendItem(IDT_VFORM,IDM_StandardShellMenu_View_Form_ID)
	oTB:AddTipText(IDT_VFORM,IDM_StandardShellMenu_View_Form_ID,"Form View")

	oTB:AppendItem(IDT_VGBROWSE,IDM_StandardShellMenu_View_Table_ID)
	oTB:AddTipText(IDT_VGBROWSE,IDM_StandardShellMenu_View_Table_ID,"Browse View")

	oTB:Flat := true

	self:ToolBar := oTB

	self:Accelerator := StandardShellMenu_Accelerator{ }

	return self
END CLASS
CLASS StandardShellMenu_Accelerator INHERIT Accelerator
 
CONSTRUCTOR( ) 
	SUPER(ResourceID{IDA_StandardShellMenu, _GetInst( )})

	return self
END CLASS
